%%%
clear variables; clc;

addpath('../library/')

% I fitted euro area GDP growth to skewn-normal distribution
location = [0.8176; 0.4629];
scale    = [1.1517; 0.3453];
shape    = [-6.1955;0.2638];

x=-3:0.05:3;

density2 = dsn(x,location(1),scale(1),shape(1));
density1 = dsn(x,location(2),scale(2),shape(2));

make_it_tight = true;                     % GAP        LOWER UPPER  LEFT RIGHT
subplot = @(m,n,p) subtightplot (m, n, p, [0.08 0.08], [0.105 0.03], [0.08 0.08]);
if ~make_it_tight,  clear subplot;  end

figure;
subplot(1,1,1)
a=area(x,density1,'FaceColor',	[0, 0.4470, 0.7410]	, 'EdgeColor', 	[0, 0.4470, 0.7410]);
hold on
b=area(x,density2,'FaceColor',	[0.8500, 0.3250, 0.0980]	, 'EdgeColor', [0.8500, 0.3250, 0.0980]);
a.FaceAlpha = 0.6;
b.FaceAlpha = 0.6;
hold on
xlabel('quarter-over-quarter real GDP growth rates (%)')
grid on; box on;
legend('Non-distress periods','Distress Periods','Location','NorthWest')
ylabel('density function')
ylim([0 1.5])
xlim([-3 2])

set(gcf,'PaperUnits','inches');
set(gcf,'PaperSize',[6.5 5]);
set(gcf,'PaperPositionMode','manual');
set(gcf,'PaperPosition',[0 0 6.5 5]);

set(gcf,'renderer','painters');
eval(['print -dpdf pdf/Fig02']);

