
clear variables; close all; clc;

addpath('../library')

load('../results/models/benchmark/posterior_mode.mat','pr_st0');

BinDate = datetime('2/1999','InputFormat','QQ/yyyy');
EndDate = datetime('4/2019','InputFormat','QQ/yyyy');

Date = BinDate:calquarters(1):EndDate;

smb1=pr_st0(:,1)+pr_st0(:,2)+pr_st0(:,5)+pr_st0(:,6);
smb2=pr_st0(:,1)+pr_st0(:,3)+pr_st0(:,5)+pr_st0(:,7);
smb3=pr_st0(:,1)+pr_st0(:,2)+pr_st0(:,3)+pr_st0(:,4);

make_it_tight = true;                     % GAP        LOWER UPPER  LEFT RIGHT
subplot = @(m,n,p) subtightplot (m, n, p, [0.08 0.01], [0.20 0.10], [0.05 0.01]);
if ~make_it_tight,  clear subplot;  end

figure;
subplot(1,3,1)
a=area([datetime('01/2008','InputFormat','MM/yyyy') datetime('06/2009','InputFormat','MM/yyyy')], [30 30],-10);
hold on
b=area([datetime('09/2011','InputFormat','MM/yyyy') datetime('01/2013','InputFormat','MM/yyyy')], [30 30],-10);
set(a,'FaceColor',[255/255 250/255 205/255], 'EdgeColor', 'y')
set(b,'FaceColor',[255/255 250/255 205/255], 'EdgeColor', 'y')
%hold on
cc=plot(Date',smb1,'LineWidth', 1.3,'color',[0 0.4470 0.7410]);
%set(c,'FaceColor',[0, 0.4470, 0.7410], 'EdgeColor', 'k')
%c.FaceAlpha = 0.5;
ylabel('prob.')
xticks(datetime('01/1998','InputFormat','MM/yyyy'):calquarters(8):datetime('12/2020','InputFormat','MM/yyyy'))
xlabel('years')
t=title('Panel A. location parameter');
set(t, 'horizontalAlignment', 'left')
set(t, 'units', 'normalized')
h = get(t, 'position');
set(t, 'position', [0 1 0])
ylim([-0.05 1.05])
box on
grid on
ylabel({'Prob.'})
%set(gca,'FontSize', 8)
xtickangle(45)
subplot(1,3,2)
a=area([datetime('01/2008','InputFormat','MM/yyyy') datetime('06/2009','InputFormat','MM/yyyy')], [30 30],-10);
hold on
b=area([datetime('09/2011','InputFormat','MM/yyyy') datetime('01/2013','InputFormat','MM/yyyy')], [30 30],-10);
set(a,'FaceColor',[255/255 250/255 205/255], 'EdgeColor', 'y')
set(b,'FaceColor',[255/255 250/255 205/255], 'EdgeColor', 'y')
%xlim([datetime('Q1/1998','InputFormat','QQ/yyyy') datetime('Q4/2020','InputFormat','QQ/yyyy')])
hold on
cc=plot(Date',smb2,'LineWidth', 1.3,'color',[0 0.4470 0.7410]);
%ylabel('prob.')
xlabel('years')
set(gca,'yticklabel',[])
xticks(datetime('01/1998','InputFormat','MM/yyyy'):calquarters(8):datetime('12/2020','InputFormat','MM/yyyy'))
t=title('Panel B. scale parameter');
set(t, 'horizontalAlignment', 'left')
set(t, 'units', 'normalized')
h = get(t, 'position');
set(t, 'position', [0 1 0])
ylim([-0.05 1.05])
box on
grid on
%ylabel({'Prob. of being','in regime 1'})
%set(gca,'FontSize', 8)
xtickangle(45)
%legend([cc,a],'Prob. of being in regime 1','CEPR recessions');
subplot(1,3,3)
a=area([datetime('01/2008','InputFormat','MM/yyyy') datetime('06/2009','InputFormat','MM/yyyy')], [30 30],-10);
hold on
b=area([datetime('09/2011','InputFormat','MM/yyyy') datetime('01/2013','InputFormat','MM/yyyy')], [30 30],-10);
set(a,'FaceColor',[255/255 250/255 205/255], 'EdgeColor', 'y')
set(b,'FaceColor',[255/255 250/255 205/255], 'EdgeColor', 'y')
hold on
%area(Date',[smb3,1-smb3]);%,'LineWidth', 1.5,'color',[0 0.4470 0.7410])
plot(Date',smb3,'LineWidth', 1.3,'color',[0 0.4470 0.7410])
%area(Date',smb3);%,'LineWidth', 1.5,'color',[0 0.4470 0.7410])
%ylabel({'Prob. of being','in regime 1'})
xlabel('years')
xticks(datetime('01/1998','InputFormat','MM/yyyy'):calquarters(8):datetime('12/2020','InputFormat','MM/yyyy'))
set(gca,'yticklabel',[])
t=title('Panel C. shape parameter');
set(t, 'horizontalAlignment', 'left')
set(t, 'units', 'normalized')
h = get(t, 'position');
set(t, 'position', [0 1 0])
ylim([-0.05 1.05])
box on
grid on
%set(gca,'FontSize', )
xtickangle(45)

set(gcf,'PaperUnits','inches');
set(gcf,'PaperSize',[9 3]);
set(gcf,'PaperPositionMode','manual');
set(gcf,'PaperPosition',[0 0 9 3]);

set(gcf,'renderer','painters');
eval('print -dpdf pdf/Fig03');

