function [M, rej] = gbs_adjshape(M)

adjshape_old    = M.params.adjshape;

adjshape_new    = NaN(length(adjshape_old),1);
adjshape_new(M.regimes(1,:)==1) = adjshape_old(M.regimes(1,:)==1) + M.prior.shape.c(1)*randn();
adjshape_new(M.regimes(1,:)==0) = adjshape_old(M.regimes(1,:)==0) + M.prior.shape.c(2)*randn();

s = sum(M.s==find(M.regimes(1,:)),2) + 2*(1-sum(M.s==find(M.regimes(1,:)),2));

lnlikmat_new = lnpost_adjshape(adjshape_new,M);
lnlikmat_old = lnpost_adjshape(adjshape_old,M);

lnpost_new = NaN(2,1);
lnpost_old = NaN(2,1);
for i=1:2
    lnpost_new(i) = sum(lnlikmat_new(s==i));
    lnpost_old(i) = sum(lnlikmat_old(s==i));
end

r1 = min([1 ; exp(lnpost_new(1) - lnpost_old(1))]);      
r2 = min([1 ; exp(lnpost_new(2) - lnpost_old(2))]);      

rej      = NaN(2,1);
adjshape = NaN(2,1);
    
if ( (rand() < r1) && (abs(adjshape_new(1))<0.99) ) 
    adjshape(1) = adjshape_new(1);
    rej(1)=0;
else
    adjshape(1) = adjshape_old(1);
    rej(1)=1;
end

if ( (rand() < r2) && (abs(adjshape_new(5))<0.99) )
    adjshape(2) = adjshape_new(5);
    rej(2)=0;
else
    adjshape(2) = adjshape_old(5);
    rej(2)=1;
end

M.params.adjshape(M.regimes(1,:)==1) = adjshape(1,1);
M.params.adjshape(M.regimes(1,:)==0) = adjshape(2,1);

M.params.shape  = M.params.adjshape./(sqrt(1-M.params.adjshape.^2));