function M = gbs_s_single_move(M)

lnlikcond = zeros(M.t,M.nreg);
Q         = zeros(M.nreg,M.nreg,M.t);

for i=1:M.t
    % evaluate likelihood conditional on the historical path of st
    lnlikcond(i,:) = lik_conditional_st(M.params.location, M.params.scale, M.params.shape, M.params.phi, M.yt(i,1:2));
    % evaluate transition matrix
    if M.nreg>2 % independent MS processes
        Q(:,:,i) = tran_p2q(M.params.a1,M.params.a2,M.params.b1,M.params.b2,M.yt(i,2:end));
    else        % synchronized MS processes
        Q(:,:,i) = tran_p2q_synchronized(M.params.a1,M.params.a2,M.params.b1,M.params.b2,M.yt(i,2:end));    
    end
end

terminal = 0;
while terminal == 0
    Pr = NaN(1,M.nreg);
    j  = M.t-1;
    
    while j>=2
        stl=M.s(j-1);
        stf=M.s(j+1);
        for st=1:M.nreg
            Pr(1,st)=exp(log(Q(st,stl,j)) + lnlikcond(j,st) + log(Q(stf,st,j+1)));
        end
        M.s(j)=bingen1(Pr);
        j=j-1;
    end
    
    tmp = NaN(3,1);
    for ij=1:3
        tmp1 = sum(M.s==find(M.regimes(ij,:)),2);
        tmp(ij,1) = (sum(tmp1 == 1) > 1) && (sum(tmp1 == 0) > 1);        
    end
    
    if all(tmp)
        terminal=1;
    end
end
