function M = gbs_shape(M)

s     = sum(M.s==find(M.regimes(1,:)),2) + 2*(1-sum(M.s==find(M.regimes(1,:)),2));
ystar = (M.yt(:,1)-M.yt(:,2).*M.params.phi-M.params.location(M.s))./M.params.scale(M.s);
alp   = NaN(2,1);

terminal = 0;
while terminal == 0
    for i=1:2
        ystar_ = ystar(s==i);
        
        BigDelta_ = M.prior.shape.sig(i)*ystar_.*(M.prior.shape.sig(i)^2*ystar_.^2+1).^(-1/2);
        n         = size(BigDelta_,1);
        BigGamma_ = eye(n)-diag(BigDelta_).^2+BigDelta_*BigDelta_';
        
        % parameters to SUN Distribution by Arellano-Valle and Azzalini (2006)
        xi       = M.prior.shape.mu(i);
        gam      = BigDelta_*M.prior.shape.mu(i)/M.prior.shape.sig(i);
        omega    = M.prior.shape.sig(i);
        BigOmega = 1;
        BigDelta = BigDelta_;
        BigGamma = BigGamma_;
        
        % see Azzalini (2014), page 208
        BigPsi = BigOmega-BigDelta'*inv(BigGamma)*BigDelta;
        U0     = normrnd(0,sqrt(BigPsi));
        
        % Truncated multivariate normal from MATLAB File Exchange by Zdravko Botev
        % "The normal law under linear restrictions: simulation and estimation
        % via minimax tilting", JRSS, 2016
        lbound = ones(n,1).*gam*(-1);
        ubound = Inf(n,1);
        U1     = mvrandn(lbound,ubound,BigGamma,1);
        
        % see equation 7.4 in Azzalini (2014)
        alp(i,1) = xi + omega*(U0+BigDelta'*inv(BigGamma)*U1);
    end
    if alp(1,1)<alp(2,1)
        terminal=1;
    end
end

M.params.shape(M.regimes(1,:)==1) = alp(1,1);
M.params.shape(M.regimes(1,:)==0) = alp(2,1);

M.params.adjshape  = M.params.shape./(sqrt(1+M.params.shape.^2));
