function M = gbs_transition_matrix(M)

for i=1:M.nprocess
    
    u = NaN(M.t,1);
    s = sum(M.s==find(M.regimes(i,:)),2) + 2*(1-sum(M.s==find(M.regimes(i,:)),2));
    
    for j=2:M.t
        terminal=0;
        while terminal==0
            nu = randn;
            if (s(j)==1) && (s(j-1)==1)
                z=(-M.params.a1(i)-M.yt(j,2:end)*M.params.b1(:,i));
                idx=nu<z;
            elseif (s(j)==1) && (s(j-1)==2)
                z=(-M.params.a1(i)-M.params.a2(i)-M.yt(j,2:end)*M.params.b2(:,i));
                idx=nu<z;
            elseif (s(j)==2) && (s(j-1)==1)
                z=(-M.params.a1(i)-M.yt(j,2:end)*M.params.b1(:,i));
                idx=nu>=z;
            elseif (s(j)==2) && (s(j-1)==2)
                z=(-M.params.a1(i)-M.params.a2(i)-M.yt(j,2:end)*M.params.b2(:,i));
                idx=nu>=z;
            end
            if idx
                u(j)     = nu;
                terminal = 1;
            end
        end
    end
 
    Y = M.params.a1(i) + M.params.a2(i)*(s(1:end-1)-1) + M.yt(2:end,2:end)*M.params.b1(:,i).*(2-s(1:end-1)) + M.yt(2:end,2:end)*M.params.b2(:,i).*(s(1:end-1)-1) + u(2:end);
    
    switch M.name_file
        case {'ftp','normal'}
            X = [ones(M.t-1,1) (s(1:end-1)-1)];
            V = inv( inv(M.prior.transition_matrix.sig(1:2,1:2,i)) + X'*X );
            n = ( inv(M.prior.transition_matrix.sig(1:2,1:2,i)) + X'*X )\( M.prior.transition_matrix.sig(1:2,1:2,i)\M.prior.transition_matrix.mu(1:2,i) + X'*Y );
        case 'onlyGDP'
            X = [ones(M.t-1,1) (s(1:end-1)-1) M.yt(2:end,2).*(2-s(1:end-1)) M.yt(2:end,2).*(s(1:end-1)-1)];
            V = inv( inv(M.prior.transition_matrix.sig([1,2,3,5],[1,2,3,5],i)) + X'*X );
            n = ( inv(M.prior.transition_matrix.sig([1,2,3,5],[1,2,3,5],i)) + X'*X )\( M.prior.transition_matrix.sig([1,2,3,5],[1,2,3,5],i)\M.prior.transition_matrix.mu([1,2,3,5],i) + X'*Y );
        case {'benchmark','loose025','loose050'}
            X = [ones(M.t-1,1) (s(1:end-1)-1) M.yt(2:end,2).*(2-s(1:end-1)) M.yt(2:end,3).*(2-s(1:end-1)) M.yt(2:end,2).*(s(1:end-1)-1) M.yt(2:end,3).*(s(1:end-1)-1)];
            V = inv( inv(M.prior.transition_matrix.sig(:,:,i)) + X'*X );
            n = ( inv(M.prior.transition_matrix.sig(:,:,i)) + X'*X )\( M.prior.transition_matrix.sig(:,:,i)\M.prior.transition_matrix.mu(:,i) + X'*Y );
    end
    
    bet = mvnrnd(n,V);

    switch M.name_file
        case {'ftp','normal'}
            M.params.a1(i) = bet(1);
            M.params.a2(i) = bet(2);
        case 'onlyGDP'
            M.params.a1(i) = bet(1);
            M.params.a2(i) = bet(2);
            M.params.b1(1,i) = bet(3);
            M.params.b2(1,i) = bet(4);            
        case {'benchmark','loose025','loose050'}
            M.params.a1(i) = bet(1);
            M.params.a2(i) = bet(2);
            M.params.b1(:,i) = [bet(3); bet(4)];
            M.params.b2(:,i) = [bet(5); bet(6)];
    end

end

