function spdraw=mcdraw_f2_most_likely(H,sp)
% =========================================================================
% Code for "Escaping the Great Recession"
% by Francesco Bianchi and Leonardo Melosi
% American Economic Review, forthcoming
% This function draws the most likely path based on the filtered 
% probabilities sp and the transition matrix H
% =========================================================================

%if abs(sum(sum(H))-size(H,1))>=10^-10;disp('Error');fff;end
T=size(sp,1);

spdraw=zeros(T,1);
p=sp(T,:);
for it=T:-1:2
   [~,imax]=max(p);
   spdraw(it)=imax;
   p= H(spdraw(it),:).*sp(it-1,:);  %NEW
end
[~,imax]=max(p);
spdraw(1)=imax;
