
clear variables; close all; clc;

model_name    = [{'benchmark'},{'onlyGDP'},{'ftp'}];
model_texname = [{'GDP + CISS'},{'only GDP'},{'FTP'}];

criteria_indep = cell(length(model_name),1);
criteria_synch = cell(length(model_name),1);
for i=1:length(model_name)
    criteria_indep{i} = load(['../results/models/',model_name{i},'/WAIC.mat']);
    criteria_synch{i} = load(['../synchronized/results/models/',model_name{i},'/WAIC.mat']);
end
criteria_indep = [criteria_indep{1:length(model_name)}];
criteria_synch = [criteria_synch{1:length(model_name)}];

% criteria
waic_indep       = cat(1,criteria_indep.waic)*(-1);
se_waic_indep    = cat(1,criteria_indep.se_elpd_waic);
elpd1_waic_indep = cat(2,criteria_indep.elpd_waici);

waic_synch        = cat(1,criteria_synch.waic)*(-1);
se_waic_synch     = cat(1,criteria_synch.se_elpd_waic);
elpd1_waic_synch  = cat(2,criteria_synch.elpd_waici);

waic_comp    = waic_indep-waic_synch;
se_comp_waic = sqrt(size(elpd1_waic_synch,1)*var(elpd1_waic_indep-elpd1_waic_synch));

% Table in lateX format
fprintf('\n')
fprintf('\\begin{table}\n')
fprintf('{\\footnotesize\n')
fprintf('\\begin{threeparttable}\n')
fprintf('\\center\n')
fprintf('\\caption{Information criteria}\n')
fprintf('\\label{tab:criteria}\n')
fprintf('\\begin{tabular}{lccc}\n')
fprintf(' \\hline\n ')
fprintf(' \\hline\n')
fprintf('               & &      \\multicolumn{2}{c}{\\textit{Difference relative to synchronized-chains model}}  \\\\\n')
fprintf(' \\cline{3-4}\n')
fprintf('\\textit{Independent-chains model} & & WAIC & standard errors \\\\\n')
fprintf(' \\hline\n')
for i=1:length(model_name)
fprintf([model_texname{i},'  & & $%.4f$ & $%.4f$ \\\\\n'], waic_comp(i), se_comp_waic(i))
end
fprintf(' \\hline\n')
fprintf('\\end{tabular}\n')
fprintf('\\begin{tablenotes}[para,flushleft]\n')
fprintf('\\small\n')
fprintf('\\textit{Note:} TBD.\n')
fprintf('\\end{tablenotes}\n')
fprintf('\\end{threeparttable}\n')
fprintf('}\n')
fprintf('\\end{table}\n')
