
clear variables; close all; clc;

model_name    = [{'benchmark'},{'onlyGDP'},{'ftp'},{'normal'}];
model_texname = [{'MS Skew-normal Model with GDP and CISS'}, ... 
                 {'MS Skew-normal Model with GDP'}, ...
                 {'MS Skew-normal Model'}, ...
                 {'MS Normal Model'}];

criteria_indep = cell(length(model_name),1);
for i=1:length(model_name)
    criteria_indep{i} = load(['../results/models/',model_name{i},'/WAIC.mat']);
end
criteria_indep = [criteria_indep{1:length(model_name)}];

% criteria
waic_indep       = cat(1,criteria_indep.waic)*(-1);
se_waic_indep    = cat(1,criteria_indep.se_elpd_waic);
elpd1_waic_indep = cat(2,criteria_indep.elpd_waici);

% Table in lateX format
fprintf('\n')
fprintf('\\begin{table}\n')
fprintf('{\\footnotesize\n')
fprintf('\\begin{threeparttable}\n')
fprintf('\\center\n')
fprintf('\\label{tab:criteria}\n')
fprintf('\\caption{Information criteria}\n')
fprintf('\\begin{tabular}{lccc}\n')
fprintf(' \\hline\n ')
fprintf(' \\hline\n')
fprintf('  & & WAIC & standard errors     \\\\\n')
fprintf(' \\hline\n')
for i=1:length(model_name)
fprintf([model_texname{i},' &  & $%.4f$ & $%.4f$ \\\\\n'], ...
          waic_indep(i), se_waic_indep(i))
end
fprintf(' \\hline\n')
fprintf('\\end{tabular}\n')
fprintf('\\begin{tablenotes}[para,flushleft]\n')
fprintf('\\small\n')
fprintf('\\textit{Note:} TBD.\n')
fprintf('\\end{tablenotes}\n')
fprintf('\\end{threeparttable}\n')
fprintf('}\n')
fprintf('\\end{table}\n')
